	LIST P=16F874
	INCLUDE<P16F874.INC>
	__CONFIG _PWRTE_ON & _WDT_OFF & _XT_OSC

;----------------------------------------------------------------------------------------------------------------------------
;Definice jednotlivch vstup
;----------------------------------------------------------------------------------------------------------------------------
#DEFINE	SIG		PORTA,0
#DEFINE	IN8		PORTA,1
#DEFINE	IN6		PORTA,2
#DEFINE	IN4		PORTA,3
#DEFINE	IN2		PORTA,4
#DEFINE	IN1		PORTA,5

#DEFINE	KL1		PORTB,0
#DEFINE	KL2		PORTB,1
#DEFINE	KL3		PORTB,2
#DEFINE	KL4		PORTB,3
#DEFINE	RS		PORTB,4
#DEFINE	E		PORTB,5
#DEFINE	LED		PORTB,6
#DEFINE	ZAL		PORTB,7

#DEFINE	OUT4	PORTC,0
#DEFINE	OUT3	PORTC,1
#DEFINE	OUT2	PORTC,2
#DEFINE	OUT1	PORTC,3

#DEFINE	IN3		PORTE,0
#DEFINE	IN5		PORTE,1
#DEFINE	IN7		PORTE,2

LCD		EQU		08h		;cel port D uren pro LCD

;----------------------------------------------------------------------------------------------------------------------------
;Definice promnnch registr
;----------------------------------------------------------------------------------------------------------------------------
temp_W		EQU	20h		;doasn uloen W pi peruen
temp_STAT	EQU	21h		;doasn uloen STATUS pi peruen
temp_PCLATH	EQU	22h		;doasn uloen PCLATH pi peruen

c1			EQU	23h		;promnn pro ekac smyky
c2			EQU	24h
c3			EQU	25h
c4			EQU	26h		;promnn pro odpoet do zhasnut podsvcen
c5			EQU	27h		;promnn pro odpoet asu zmny npisu info
c6			EQU	28h		;promnn pro odpoet asu do sputn poplachu po vstupu

priznak1	EQU	29h		;promnn pznak
priznak2	EQU	2Ah
priznak3	EQU	2Bh

p_zobr1		EQU	2Dh		;promnn pznak zobrazench sel
p_zobr2		EQU	2Eh

akt_heslo	EQU	2Fh

zad_heslo1	EQU	30h		;promnn pro zadan hesla
zad_heslo2	EQU	31h
zad_heslo3	EQU	32h
zad_heslo4	EQU	33h

ulo_heslo1	EQU	34h		;promnn pro uloen sla
ulo_heslo2	EQU	35h
ulo_heslo3	EQU	36h
ulo_heslo4	EQU	37h

#DEFINE		odp_pod		priznak1,0
#DEFINE		odp_in		priznak1,1
#DEFINE		nap_in1		priznak1,2
#DEFINE		nap_in2		priznak1,3
#DEFINE		nap_in3		priznak1,4
#DEFINE		info		priznak1,5
#DEFINE		pipej		priznak1,6
#DEFINE		spatne		priznak1,7

#DEFINE		zobr0		p_zobr1,0
#DEFINE		zobr1		p_zobr1,1
#DEFINE		zobr2		p_zobr1,2
#DEFINE		zobr3		p_zobr1,3
#DEFINE		zobr4		p_zobr1,4
#DEFINE		zobr5		p_zobr1,5
#DEFINE		zobr6		p_zobr1,6
#DEFINE		zobr7		p_zobr1,7

#DEFINE		zobr8		p_zobr2,0
#DEFINE		zobr9		p_zobr2,1

#DEFINE		hes1		priznak2,0	;prv zadvan slo
#DEFINE		hes2		priznak2,1
#DEFINE		hes3		priznak2,2
#DEFINE		hes_in		priznak2,3
#DEFINE		hes_cele	priznak2,4
#DEFINE		vstup		priznak2,5	;pznaky pro vyhodnocen poplachu
#DEFINE		pohyb		priznak2,6
#DEFINE		poplach		priznak2,7

#DEFINE		odp_vstup	priznak3,0	;nastaven odpotu asu pi vstupu


;----------------------------------------------------------------------------------------------------------------------------
;Promnn jednotlivch znak displej
;----------------------------------------------------------------------------------------------------------------------------

zn01	EQU	40h
zn02	EQU	41h
zn03	EQU	42h
zn04	EQU	43h
zn05	EQU	44h
zn06	EQU	45h
zn07	EQU	46h
zn08	EQU	47h
zn09	EQU	48h
zn10	EQU	49h
zn11	EQU	4Ah
zn12	EQU	4Bh
zn13	EQU	4Ch
zn14	EQU	4Dh
zn15	EQU	4Eh
zn16	EQU	4Fh

;----------------------------------------------------------------------------------------------------------------------------
;Definice znak displeje
;----------------------------------------------------------------------------------------------------------------------------
oct		EQU	b'11011011'	;przdn tvereek
pct		EQU	b'11111111'	;ern tvereek
psip	EQU	b'01111110'	;prav ipka
lsip	EQU	b'01111111'	;lev ipka

;----------------------------------------------------------------------------------------------------------------------------
;Oeten peruen
;----------------------------------------------------------------------------------------------------------------------------
	ORG	00h
	GOTO	zacatek

	ORG	04h
	GOTO	preruseni

zacatek

;----------------------------------------------------------------------------------------------------------------------------
;Nastaven pin mikrokontrolru
;----------------------------------------------------------------------------------------------------------------------------
;-------nastaven digitlnch a analogovch vstup

	BCF		STATUS,RP0
	BCF		STATUS,RP1 		; pepnut do banky 0

	CLRF	PORTA 			; nastaven portu A jako vstupy
	BSF		STATUS,RP0 		; pepnut do banky 1
	MOVLW	0x06 			; nastaven vech pin jako digitln
	MOVWF	ADCON1

	BCF		STATUS,RP1
	BSF		STATUS,RP0

;-------nastaven vstup-1 / vstup-0

	MOVLW	b'00000000'
	MOVWF	TRISA

	MOVLW	b'10001111'
	MOVWF	TRISB

	MOVLW	b'10010000'
	MOVWF	TRISC

	MOVLW	b'00000000'
	MOVWF	TRISD

	MOVLW	b'00000111'
	MOVWF	TRISE

;----------------------------------------------------------------------------------------------------------------------------
;Nastaven peruen
;----------------------------------------------------------------------------------------------------------------------------
	BSF		STATUS,RP0
	MOVLW	b'10000111'	
	MOVWF	OPTION_REG

	BCF		STATUS,RP0
	MOVLW	b'11100000'	
	MOVWF	INTCON

;----------------------------------------------------------------------------------------------------------------------------
;Nastaven displeje
;----------------------------------------------------------------------------------------------------------------------------
	CALL	cekani2		;ek na "nbh" displeje

	BCF		RS			;na portech bude INSTRUKCE
	MOVLW	b'00000001'	;nulovn displeje
	MOVWF	LCD
	BSF		E			;povolen penosu
	NOP	
	BCF		E		
	CALL	cekani2		;ek asi 2ms

;-----zpis na zatek
	BCF		RS			;na portech bude INSTRUKCE
	MOVLW	b'00000010'	;nastaven kurzoru na zatek
	MOVWF	LCD
	BSF		E			;povolen penosu
	NOP	
	BCF		E		
	CALL	cekani2		;ek asi 2ms

;-----smr pohybu kurzoru vpravo
	BCF		RS			;na portech bude INSTRUKCE
	MOVLW	b'00000110'	;inkrementace pi zapsn, normln prce
	MOVWF	LCD
	BSF		E			;povolen penosu
	NOP	
	BCF		E		
	CALL	cekani2		;ek asi 2ms

;-----zapnout displej a vypnout kurzor i jeho blikn
	BCF		RS			;na portech bude INSTRUKCE
	MOVLW	b'00001100'	;zapnout displej, vypnout kurzor
	MOVWF	LCD
	BSF		E			;povolen penosu
	NOP		
	BCF		E		
	CALL	cekani2		;ek asi 2ms

;-----pohyb kurzoru
	BCF		RS			;na portech bude INSTRUKCE
	MOVLW	b'00010100'	;posun kurzoru doprava po zapsn dat
	MOVWF	LCD
	BSF		E			;povolen penosu
	NOP	
	BCF		E		
	CALL	cekani2		;ek asi 2ms

;-----komunikace, poet dk
	BCF		RS			;na portech bude INSTRUKCE
	MOVLW	b'00111000'	;osmibitov komunikace, dva dky
	MOVWF	LCD
	BSF		E			;povolen penosu
	NOP		
	BCF		E		
	CALL	cekani2		;ek asi 2ms

;----------------------------------------------------------------------------------------------------------------------------
;Poten nulovn
;----------------------------------------------------------------------------------------------------------------------------
	CLRF	priznak1
	CLRF	priznak2
	CLRF	priznak3
	BSF		hes_in
	BCF		hes_cele
	BCF		spatne
	BSF		pipej

;----------------------------------------------------------------------------------------------------------------------------
;Hlavn program
;----------------------------------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------------------------------
;Inicializace
;----------------------------------------------------------------------------------------------------------------------------
main
	CALL	kl_volne
	CALL	vymaz
	BSF		info
	BSF		nap_in3
	BCF		nap_in1
	BCF		nap_in2
	BSF		odp_in
	BSF		hes1

uvod
	BTFSS	KL3
	GOTO	uvod
	BCF		info

;-----Po stisku tlatka se pejde na inicializaci hesla
	CALL	kl_volne
	CALL	vymaz
	CALL	zadej

inicializace
	CALL	heslo
inicializace2

	BTFSC	KL3
	GOTO	main

	BTFSS	hes_cele
	GOTO	inicializace

	BTFSS	KL4
	GOTO	inicializace2
	CALL	kl_volne

;-----pokud je inicializace hesla ukonena, pokrauje na dal nabdku
	CALL	ulozeno
	CALL	cekani1

menu
	BCF		hes_cele
	BCF		hes_in
	BSF		hes1
menu1
	CALL	kl_volne
	CALL	vymaz
	CALL	nap_zastrez
menu2
	BTFSC	KL1
	GOTO	zastrez
	BTFSS	KL4
	GOTO	menu2

;-----pi stisku ipky pepne na druhou st nabdky
menu3
	CALL	kl_volne
	CALL	vymaz
	CALL	nap_zmen
	BSF		hes1

menu4
	BTFSC	KL1
	GOTO	zmena
	BTFSS	KL4
	GOTO	menu4

;-----pi stisku ipky pepne na prvn st nabdky
	GOTO	menu1

;-----zmna hesla - zadn starho
zmena
	CALL	kl_volne
	CALL	vymaz
	CALL	zadej
	BSF		hes1

zmena1
	CALL	heslo
zmena2
	BTFSC	KL3
	GOTO	menu3
	BTFSS	hes_cele
	GOTO	zmena1

	BTFSS	KL4
	GOTO	zmena2
	CALL	kl_volne
	
	CALL	porovnej

	BTFSC	spatne
	GOTO	zmena

;-----zmna hesla - zadn novho
	CALL	vymaz
	CALL	zadej_nove
	CALL	cekani1

	BSF		hes_in
	BCF		hes_cele
	BCF		spatne

	CALL	vymaz
	CALL	zadej

zmena3
	CALL	heslo
zmena4
	BTFSC	KL3
	GOTO	menu3

	BTFSS	hes_cele
	GOTO	zmena3

	BTFSS	KL4
	GOTO	zmena4
	CALL	kl_volne

	BCF		hes_cele
	BCF		hes_in

	CALL	ulozeno
	CALL	cekani1

	GOTO	menu3

;-----zasteen objektu
zastrez
	CALL	kl_volne
	CALL	vymaz
	CALL	zadej
	BSF		hes1

zastrez1
	CALL	heslo
zastrez2
	BTFSC	KL3
	GOTO	menu
	BTFSS	hes_cele
	GOTO	zastrez1

	BTFSS	KL4
	GOTO	zastrez2
	CALL	kl_volne
	
	CALL	porovnej
	BCF		hes_cele

	BTFSC	spatne
	GOTO	zastrez

;-----Odpoet do aktivace alarmu
	CALL	vymaz
	CALL	odp
	BTFSC	KL4
	GOTO	menu
	CALL	cekani1
	CALL	odp1
	CALL	pip5
	BTFSC	KL4
	GOTO	menu
	CALL	cekani1
	CALL	odp2
	CALL	pip5
	BTFSC	KL4
	GOTO	menu
	CALL	cekani1
	CALL	odp3
	CALL	pip5
	BTFSC	KL4
	GOTO	menu
	CALL	cekani1
	CALL	odp4
	CALL	pip5
	BTFSC	KL4
	GOTO	menu
	CALL	cekani1
	CALL	odp5
	CALL	pip5
	BTFSC	KL4
	GOTO	menu
	CALL	cekani1
	CALL	odp6
	CALL	pip5
	BTFSC	KL4
	GOTO	menu
	CALL	cekani1
	CALL	odp7
	CALL	pip5
	BTFSC	KL4
	GOTO	menu
	CALL	cekani1
	CALL	odp8
	CALL	pip5
	BTFSC	KL4
	GOTO	menu
	CALL	cekani1

	CALL	aktivni
	CALL	pip5
	CALL	cekani1

	BCF		vstup
	BCF		pohyb

;-----Hldn idel
hlidani
	CALL	cidla

;-----Vyhodnocen stavu idel: IN1-IN4 - zpodn, IN5-IN8 - okamit sputn poplachu
	BTFSS	pohyb
	GOTO	hlidani1
	BSF		poplach
	GOTO	hlidani2

hlidani1
	BTFSS	vstup
	GOTO	hlidani5
	BCF		odp_vstup

hlidani2
	CALL	kl_volne
	CALL	vymaz
	CALL	zadej
	BSF		hes1

hlidani3
	CALL	heslo
	CALL	cidla
hlidani4
	BTFSC	KL3
	GOTO	hlidani2
	BTFSS	hes_cele
	GOTO	hlidani3

	BTFSS	KL4
	GOTO	hlidani4
	CALL	kl_volne
	
	CALL	porovnej
	BCF		hes_cele

	BTFSC	spatne
	GOTO	hlidani2

	BCF		vstup
	BCF		pohyb
	BCF		poplach
	BCF		hes_cele

	GOTO	menu

hlidani5
	GOTO	hlidani

;-----Konec hlavnho programu
	GOTO	main

;-----Hldn idel
cidla
	BTFSC	IN1
	BSF		vstup
	BTFSC	IN2
	BSF		vstup
	BTFSC	IN3
	BSF		vstup
	BTFSC	IN4
	BSF		vstup

	BTFSC	IN5
	BSF		pohyb
	BTFSC	IN6
	BSF		pohyb
	BTFSC	IN7
	BSF		pohyb
	BTFSC	IN8
	BSF		pohyb

	RETURN

;----------------------------------------------------------------------------------------------------------------------------
;Podprogram pro zadn hesla
;----------------------------------------------------------------------------------------------------------------------------
heslo
	BTFSC	KL1			;Stisknuto "+"?
	CALL	navys		;Navy zobrazen slo

	BTFSC	KL2			;Stisknuto "-"?
	CALL	sniz		;Sni zobrazen slo

	BTFSS	KL4
	RETURN

	CALL	kl_volne

	BTFSS	hes_cele
	CALL	uloz		;ulo aktuln znak

	RETURN

;-----Uloen aktulnho sla
uloz
	BTFSS	hes1
	GOTO	uloz1
	MOVFW	akt_heslo
	MOVWF	zad_heslo1
	BTFSC	hes_in
	MOVWF	ulo_heslo1
	CALL	hv1
	BCF		hes1
	BSF		hes2
	RETURN

uloz1
	BTFSS	hes2
	GOTO	uloz2
	MOVFW	akt_heslo
	MOVWF	zad_heslo2
	BTFSC	hes_in
	MOVWF	ulo_heslo2
	CALL	hv2
	BCF		hes2
	BSF		hes3
	RETURN

uloz2
	BTFSS	hes3
	GOTO	uloz3
	MOVFW	akt_heslo
	MOVWF	zad_heslo3
	BTFSC	hes_in
	MOVWF	ulo_heslo3
	CALL	hv3
	BCF		hes3
	RETURN

uloz3
	MOVFW	akt_heslo
	MOVWF	zad_heslo4
	BTFSC	hes_in
	MOVWF	ulo_heslo4
	CALL	hv4
	BSF		hes1
	BSF		hes_cele

	RETURN

;----------------------------------------------------------------------------------------------------------------------------
;Podprogram pro porovnn hesel
;----------------------------------------------------------------------------------------------------------------------------
porovnej
	BCF		spatne
	BCF		INTCON,GIE		;vechna peruen zakzna

;-------
porovnej1
	BTFSS	zad_heslo1,0	;je nult bit prvnho zadanho sla 1?
	GOTO	porovnej2		;ano - pokrauj

	BTFSC	ulo_heslo1,0	;ne, je nult bit prvnho uloenho sla 0?
	GOTO	porovnej2		;ne - pokrauj
	BSF		spatne			;ano - patn heslo

porovnej2
	BTFSC	zad_heslo1,0	;je nult bit prvnho zadanho sla 0?
	GOTO	porovnej3		;ano - pokrauj

	BTFSS	ulo_heslo1,0	;ne, je nult bit prvnho uloenho sla 1?
	GOTO	porovnej3		;ne - pokrauj
	BSF		spatne			;ano - patn heslo

;-------
porovnej3
	BTFSS	zad_heslo1,1	;nsledujc podobn, jako pedchoz
	GOTO	porovnej4

	BTFSC	ulo_heslo1,1
	GOTO	porovnej4
	BSF		spatne

porovnej4
	BTFSC	zad_heslo1,1
	GOTO	porovnej5

	BTFSS	ulo_heslo1,1
	GOTO	porovnej5
	BSF		spatne

;-------
porovnej5
	BTFSS	zad_heslo1,2
	GOTO	porovnej6

	BTFSC	ulo_heslo1,2
	GOTO	porovnej6
	BSF		spatne

porovnej6
	BTFSC	zad_heslo1,2
	GOTO	porovnej7

	BTFSS	ulo_heslo1,2
	GOTO	porovnej7
	BSF		spatne

;-------
porovnej7
	BTFSS	zad_heslo1,3
	GOTO	porovnej8

	BTFSC	ulo_heslo1,3
	GOTO	porovnej8
	BSF		spatne

porovnej8
	BTFSC	zad_heslo1,3
	GOTO	porovnej9

	BTFSS	ulo_heslo1,3
	GOTO	porovnej9
	BSF		spatne

;-------
porovnej9
	BTFSS	zad_heslo2,0
	GOTO	porovnej10

	BTFSC	ulo_heslo2,0
	GOTO	porovnej10
	BSF		spatne

porovnej10
	BTFSC	zad_heslo2,0
	GOTO	porovnej11

	BTFSS	ulo_heslo2,0
	GOTO	porovnej11
	BSF		spatne

;-------
porovnej11
	BTFSS	zad_heslo2,1
	GOTO	porovnej12

	BTFSC	ulo_heslo2,1
	GOTO	porovnej12
	BSF		spatne

porovnej12
	BTFSC	zad_heslo2,1
	GOTO	porovnej13

	BTFSS	ulo_heslo2,1
	GOTO	porovnej13
	BSF		spatne

;-------
porovnej13
	BTFSS	zad_heslo2,2
	GOTO	porovnej14

	BTFSC	ulo_heslo2,2
	GOTO	porovnej14
	BSF		spatne

porovnej14
	BTFSC	zad_heslo2,2
	GOTO	porovnej15

	BTFSS	ulo_heslo2,2
	GOTO	porovnej15
	BSF		spatne

;-------
porovnej15
	BTFSS	zad_heslo2,3
	GOTO	porovnej16

	BTFSC	ulo_heslo2,3
	GOTO	porovnej16
	BSF		spatne

porovnej16
	BTFSC	zad_heslo2,3
	GOTO	porovnej17

	BTFSS	ulo_heslo2,3
	GOTO	porovnej17
	BSF		spatne

;-------
porovnej17
	BTFSS	zad_heslo3,0
	GOTO	porovnej18

	BTFSC	ulo_heslo3,0
	GOTO	porovnej18
	BSF		spatne

porovnej18
	BTFSC	zad_heslo3,0
	GOTO	porovnej19

	BTFSS	ulo_heslo3,0
	GOTO	porovnej19
	BSF		spatne

;-------
porovnej19
	BTFSS	zad_heslo3,1
	GOTO	porovnej20

	BTFSC	ulo_heslo3,1
	GOTO	porovnej20
	BSF		spatne

porovnej20
	BTFSC	zad_heslo3,1
	GOTO	porovnej21

	BTFSS	ulo_heslo3,1
	GOTO	porovnej21
	BSF		spatne

;-------
porovnej21
	BTFSS	zad_heslo3,2
	GOTO	porovnej22

	BTFSC	ulo_heslo3,2
	GOTO	porovnej22
	BSF		spatne

porovnej22
	BTFSC	zad_heslo3,2
	GOTO	porovnej23

	BTFSS	ulo_heslo3,2
	GOTO	porovnej23
	BSF		spatne

;-------
porovnej23
	BTFSS	zad_heslo3,3
	GOTO	porovnej24

	BTFSC	ulo_heslo3,3
	GOTO	porovnej24
	BSF		spatne

porovnej24
	BTFSC	zad_heslo3,3
	GOTO	porovnej25

	BTFSS	ulo_heslo3,3
	GOTO	porovnej25
	BSF		spatne

;-------
porovnej25
	BTFSS	zad_heslo4,0
	GOTO	porovnej26

	BTFSC	ulo_heslo4,0
	GOTO	porovnej26
	BSF		spatne

porovnej26
	BTFSC	zad_heslo4,0
	GOTO	porovnej27

	BTFSS	ulo_heslo4,0
	GOTO	porovnej27
	BSF		spatne

;-------
porovnej27
	BTFSS	zad_heslo4,1
	GOTO	porovnej28

	BTFSC	ulo_heslo4,1
	GOTO	porovnej28
	BSF		spatne

porovnej28
	BTFSC	zad_heslo4,1
	GOTO	porovnej29

	BTFSS	ulo_heslo4,1
	GOTO	porovnej29
	BSF		spatne

;-------
porovnej29
	BTFSS	zad_heslo4,2
	GOTO	porovnej30

	BTFSC	ulo_heslo4,2
	GOTO	porovnej30
	BSF		spatne

porovnej30
	BTFSC	zad_heslo4,2
	GOTO	porovnej31

	BTFSS	ulo_heslo4,2
	GOTO	porovnej31
	BSF		spatne

;-------
porovnej31
	BTFSS	zad_heslo4,3
	GOTO	porovnej32

	BTFSC	ulo_heslo4,3
	GOTO	porovnej32
	BSF		spatne

porovnej32
	BTFSC	zad_heslo4,3
	GOTO	porovnej33

	BTFSS	ulo_heslo4,3
	GOTO	porovnej33
	BSF		spatne

;-------
porovnej33
	BSF	INTCON,GIE		;vechna peruen povolena

	BTFSS	spatne
	RETURN
	CALL	spat_heslo	;npis patn heslo
	CALL	cekani1

	RETURN

;----------------------------------------------------------------------------------------------------------------------------
;Podprogramy pro pravu zobrazovanch sel pi zadvn hesla
;----------------------------------------------------------------------------------------------------------------------------
;-----zven zobrazovanho sla
navys
	CALL	kl_volne

	BTFSS	zobr0
	GOTO	navys1
	CALL	cislo1	
	RETURN

navys1
	BTFSS	zobr1
	GOTO	navys2
	CALL	cislo2	
	RETURN

navys2
	BTFSS	zobr2
	GOTO	navys3
	CALL	cislo3	
	RETURN

navys3
	BTFSS	zobr3
	GOTO	navys4
	CALL	cislo4	
	RETURN

navys4
	BTFSS	zobr4
	GOTO	navys5
	CALL	cislo5	
	RETURN

navys5
	BTFSS	zobr5
	GOTO	navys6
	CALL	cislo6	
	RETURN

navys6
	BTFSS	zobr6
	GOTO	navys7
	CALL	cislo7	
	RETURN

navys7
	BTFSS	zobr7
	GOTO	navys8
	CALL	cislo8	
	RETURN

navys8
	CALL	cislo9	
	RETURN

;-----snen zobrazovanho sla
sniz
	CALL	kl_volne

	BTFSS	zobr9
	GOTO	sniz1
	CALL	cislo8	
	RETURN

sniz1
	BTFSS	zobr8
	GOTO	sniz2
	CALL	cislo7
	RETURN

sniz2
	BTFSS	zobr7
	GOTO	sniz3
	CALL	cislo6	
	RETURN

sniz3
	BTFSS	zobr6
	GOTO	sniz4
	CALL	cislo5	
	RETURN

sniz4
	BTFSS	zobr5
	GOTO	sniz5
	CALL	cislo4
	RETURN

sniz5
	BTFSS	zobr4
	GOTO	sniz6
	CALL	cislo3
	RETURN

sniz6
	BTFSS	zobr3
	GOTO	sniz7
	CALL	cislo2
	RETURN

sniz7
	BTFSS	zobr2
	GOTO	sniz8
	CALL	cislo1
	RETURN

sniz8
	CALL	cislo0
	RETURN

;----------------------------------------------------------------------------------------------------------------------------
;Podprogramy pro npisy na displeji
;----------------------------------------------------------------------------------------------------------------------------
;-----Vymazn displeje
vymaz
	BCF		RS			;na portech bude INSTRUKCE
	MOVLW	b'00000001'	;nulovn displeje
	MOVWF	LCD
	BSF		E			;povolen penosu
	NOP	
	BCF		E		
	CALL	cekani2		;ek asi 2ms

	RETURN

;-----Vpis vodnch informac
nap_info
	MOVLW	' '
	MOVWF	zn09
	MOVLW	' '
	MOVWF	zn10
	MOVLW	' '
	MOVWF	zn11
	MOVLW	'H'
	MOVWF	zn12
	MOVLW	'e'
	MOVWF	zn13
	MOVLW	's'
	MOVWF	zn14
	MOVLW	'l'
	MOVWF	zn15
	MOVLW	'o'
	MOVWF	zn16

	BTFSS	nap_in1
	GOTO	ni1
	CALL	info2
	RETURN

ni1	BTFSS	nap_in2
	GOTO	ni2
	CALL	info3
	RETURN

ni2	BTFSC	nap_in3
	CALL	info1

	RETURN

;-----Npis: Domovn
info1
	MOVLW	'D'
	MOVWF	zn01
	MOVLW	'o'
	MOVWF	zn02
	MOVLW	'm'
	MOVWF	zn03
	MOVLW	'o'
	MOVWF	zn04
	MOVLW	'v'
	MOVWF	zn05
	MOVLW	'n'
	MOVWF	zn06
	MOVLW	'i'
	MOVWF	zn07
	MOVLW	' '
	MOVWF	zn08

	BSF		nap_in1
	BCF		nap_in2
	BCF		nap_in3

	CALL	zobraz

	RETURN

;-----Npis: alarm
info2
	MOVLW	'a'
	MOVWF	zn01
	MOVLW	'l'
	MOVWF	zn02
	MOVLW	'a'
	MOVWF	zn03
	MOVLW	'r'
	MOVWF	zn04
	MOVLW	'm'
	MOVWF	zn05
	MOVLW	' '
	MOVWF	zn06
	MOVLW	' '
	MOVWF	zn07
	MOVLW	' '
	MOVWF	zn08

	BCF		nap_in1
	BSF		nap_in2
	BCF		nap_in3

	CALL	zobraz

	RETURN

;-----Npis: v.1.03
info3
	MOVLW	'v'
	MOVWF	zn01
	MOVLW	'.'
	MOVWF	zn02
	MOVLW	'1'
	MOVWF	zn03
	MOVLW	'.'
	MOVWF	zn04
	MOVLW	'0'
	MOVWF	zn05
	MOVLW	'3'
	MOVWF	zn06
	MOVLW	' '
	MOVWF	zn07
	MOVLW	' '
	MOVWF	zn08

	BCF		nap_in1
	BCF		nap_in2
	BSF		nap_in3

	CALL	zobraz

	RETURN

;-----Obrazovka pro zadvn hesla
zadej
	MOVLW	'+'
	MOVWF	zn01
	MOVLW	' '
	MOVWF	zn02
	MOVLW	' '
	MOVWF	zn03
	MOVLW	' '
	MOVWF	zn04
	MOVLW	' '
	MOVWF	zn05
	MOVLW	' '
	MOVWF	zn06
	MOVLW	'O'
	MOVWF	zn07
	MOVLW	'K'
	MOVWF	zn08

	MOVLW	'-'
	MOVWF	zn09
	MOVLW	' '
	MOVWF	zn10
	MOVLW	' '
	MOVWF	zn11
	MOVLW	' '
	MOVWF	zn12
	MOVLW	' '
	MOVWF	zn13
	MOVLW	' '
	MOVWF	zn14
	MOVLW	' '
	MOVWF	zn15
	MOVLW	lsip
	MOVWF	zn16

	CALL	cislo0

	CALL	zobraz

	RETURN

;-----Vpis jednotlivch sel pi zadvn a uloen jejich hodnot do promnn aktuln slo
cislo0
	MOVLW	'0'
	MOVWF	zn04
	CALL	zobraz
	CLRF	p_zobr1
	CLRF	p_zobr2
	MOVLW	.0
	MOVWF	akt_heslo
	BSF		zobr0
	RETURN

cislo1
	MOVLW	'1'
	MOVWF	zn04
	CALL	zobraz
	CLRF	p_zobr1
	CLRF	p_zobr2
	MOVLW	.1
	MOVWF	akt_heslo
	BSF		zobr1
	RETURN

cislo2
	MOVLW	'2'
	MOVWF	zn04
	CALL	zobraz
	CLRF	p_zobr1
	CLRF	p_zobr2
	MOVLW	.2
	MOVWF	akt_heslo
	BSF		zobr2
	RETURN

cislo3
	MOVLW	'3'
	MOVWF	zn04
	CALL	zobraz
	CLRF	p_zobr1
	CLRF	p_zobr2
	MOVLW	.3
	MOVWF	akt_heslo
	BSF		zobr3
	RETURN

cislo4
	MOVLW	'4'
	MOVWF	zn04
	CALL	zobraz
	CLRF	p_zobr1
	CLRF	p_zobr2
	MOVLW	.4
	MOVWF	akt_heslo
	BSF		zobr4
	RETURN

cislo5
	MOVLW	'5'
	MOVWF	zn04
	CALL	zobraz
	CLRF	p_zobr1
	CLRF	p_zobr2
	MOVLW	.5
	MOVWF	akt_heslo
	BSF		zobr5
	RETURN

cislo6
	MOVLW	'6'
	MOVWF	zn04
	CALL	zobraz
	CLRF	p_zobr1
	CLRF	p_zobr2
	MOVLW	.6
	MOVWF	akt_heslo
	BSF		zobr6
	RETURN

cislo7
	MOVLW	'7'
	MOVWF	zn04
	CALL	zobraz
	CLRF	p_zobr1
	CLRF	p_zobr2
	MOVLW	.7
	MOVWF	akt_heslo
	BSF		zobr7
	RETURN

cislo8
	MOVLW	'8'
	MOVWF	zn04
	CALL	zobraz
	CLRF	p_zobr1
	CLRF	p_zobr2
	MOVLW	.8
	MOVWF	akt_heslo
	BSF		zobr8
	RETURN

cislo9
	MOVLW	'9'
	MOVWF	zn04
	CALL	zobraz
	CLRF	p_zobr1
	CLRF	p_zobr2
	MOVLW	.9
	MOVWF	akt_heslo
	BSF		zobr9
	RETURN

;-----Vpis jednotlivch hvzdiek pi zadvn hesla
hv0
	MOVLW	' '
	MOVWF	zn11
	MOVLW	' '
	MOVWF	zn12
	MOVLW	' '
	MOVWF	zn13
	MOVLW	' '
	MOVWF	zn14
	CALL	zobraz
	RETURN

hv1
	MOVLW	'*'
	MOVWF	zn11
	MOVLW	' '
	MOVWF	zn12
	MOVLW	' '
	MOVWF	zn13
	MOVLW	' '
	MOVWF	zn14
	CALL	zobraz
	RETURN

hv2
	MOVLW	'*'
	MOVWF	zn11
	MOVLW	'*'
	MOVWF	zn12
	MOVLW	' '
	MOVWF	zn13
	MOVLW	' '
	MOVWF	zn14
	CALL	zobraz
	RETURN

hv3
	MOVLW	'*'
	MOVWF	zn11
	MOVLW	'*'
	MOVWF	zn12
	MOVLW	'*'
	MOVWF	zn13
	MOVLW	' '
	MOVWF	zn14
	CALL	zobraz
	RETURN

hv4
	MOVLW	'*'
	MOVWF	zn11
	MOVLW	'*'
	MOVWF	zn12
	MOVLW	'*'
	MOVWF	zn13
	MOVLW	'*'
	MOVWF	zn14
	CALL	zobraz
	RETURN

;-----Npis: Heslo uloeno
ulozeno
	MOVLW	'H'
	MOVWF	zn01
	MOVLW	'e'
	MOVWF	zn02
	MOVLW	's'
	MOVWF	zn03
	MOVLW	'l'
	MOVWF	zn04
	MOVLW	'o'
	MOVWF	zn05
	MOVLW	' '
	MOVWF	zn06
	MOVLW	' '
	MOVWF	zn07
	MOVLW	' '
	MOVWF	zn08

	MOVLW	'u'
	MOVWF	zn09
	MOVLW	'l'
	MOVWF	zn10
	MOVLW	'o'
	MOVWF	zn11
	MOVLW	'z'
	MOVWF	zn12
	MOVLW	'e'
	MOVWF	zn13
	MOVLW	'n'
	MOVWF	zn14
	MOVLW	'o'
	MOVWF	zn15
	MOVLW	' '
	MOVWF	zn16

	CALL	zobraz

	RETURN

;-----Npis: Zmen Heslo
nap_zmen
	MOVLW	'Z'
	MOVWF	zn01
	MOVLW	'm'
	MOVWF	zn02
	MOVLW	'e'
	MOVWF	zn03
	MOVLW	'n'
	MOVWF	zn04
	MOVLW	' '
	MOVWF	zn05
	MOVLW	' '
	MOVWF	zn06
	MOVLW	' '
	MOVWF	zn07
	MOVLW	psip
	MOVWF	zn08

	MOVLW	'h'
	MOVWF	zn09
	MOVLW	'e'
	MOVWF	zn10
	MOVLW	's'
	MOVWF	zn11
	MOVLW	'l'
	MOVWF	zn12
	MOVLW	'o'
	MOVWF	zn13
	MOVLW	' '
	MOVWF	zn14
	MOVLW	' '
	MOVWF	zn15
	MOVLW	' '
	MOVWF	zn16

	CALL	zobraz

	RETURN

;-----Npis: Strez objekt
nap_zastrez
	MOVLW	'S'
	MOVWF	zn01
	MOVLW	't'
	MOVWF	zn02
	MOVLW	'r'
	MOVWF	zn03
	MOVLW	'e'
	MOVWF	zn04
	MOVLW	'z'
	MOVWF	zn05
	MOVLW	' '
	MOVWF	zn06
	MOVLW	' '
	MOVWF	zn07
	MOVLW	psip
	MOVWF	zn08

	MOVLW	'o'
	MOVWF	zn09
	MOVLW	'b'
	MOVWF	zn10
	MOVLW	'j'
	MOVWF	zn11
	MOVLW	'e'
	MOVWF	zn12
	MOVLW	'k'
	MOVWF	zn13
	MOVLW	't'
	MOVWF	zn14
	MOVLW	' '
	MOVWF	zn15
	MOVLW	' '
	MOVWF	zn16

	CALL	zobraz

	RETURN

;-----Npis: Strez objekt
spat_heslo
	MOVLW	'S'
	MOVWF	zn01
	MOVLW	'p'
	MOVWF	zn02
	MOVLW	'a'
	MOVWF	zn03
	MOVLW	't'
	MOVWF	zn04
	MOVLW	'n'
	MOVWF	zn05
	MOVLW	'e'
	MOVWF	zn06
	MOVLW	' '
	MOVWF	zn07
	MOVLW	' '
	MOVWF	zn08

	MOVLW	'h'
	MOVWF	zn09
	MOVLW	'e'
	MOVWF	zn10
	MOVLW	's'
	MOVWF	zn11
	MOVLW	'l'
	MOVWF	zn12
	MOVLW	'o'
	MOVWF	zn13
	MOVLW	' '
	MOVWF	zn14
	MOVLW	' '
	MOVWF	zn15
	MOVLW	' '
	MOVWF	zn16

	CALL	zobraz

	RETURN

;-----Npis: Nov heslo
zadej_nove
	MOVLW	'N'
	MOVWF	zn01
	MOVLW	'o'
	MOVWF	zn02
	MOVLW	'v'
	MOVWF	zn03
	MOVLW	'e'
	MOVWF	zn04
	MOVLW	' '
	MOVWF	zn05
	MOVLW	' '
	MOVWF	zn06
	MOVLW	' '
	MOVWF	zn07
	MOVLW	' '
	MOVWF	zn08

	MOVLW	'h'
	MOVWF	zn09
	MOVLW	'e'
	MOVWF	zn10
	MOVLW	's'
	MOVWF	zn11
	MOVLW	'l'
	MOVWF	zn12
	MOVLW	'o'
	MOVWF	zn13
	MOVLW	' '
	MOVWF	zn14
	MOVLW	' '
	MOVWF	zn15
	MOVLW	' '
	MOVWF	zn16

	CALL	zobraz

	RETURN

;-----Odpoet pi odchodu
odp
	MOVLW	'O'
	MOVWF	zn01
	MOVLW	'd'
	MOVWF	zn02
	MOVLW	'c'
	MOVWF	zn03
	MOVLW	'h'
	MOVWF	zn04
	MOVLW	'o'
	MOVWF	zn05
	MOVLW	'd'
	MOVWF	zn06
	MOVLW	' '
	MOVWF	zn07
	MOVLW	lsip
	MOVWF	zn08

	MOVLW	oct
	MOVWF	zn09
	MOVWF	zn10
	MOVWF	zn11
	MOVWF	zn12
	MOVWF	zn13
	MOVWF	zn14
	MOVWF	zn15
	MOVWF	zn16

	CALL	zobraz

	RETURN

odp1
	MOVLW	pct
	MOVWF	zn09

	CALL	zobraz

	RETURN

odp2
	MOVLW	pct
	MOVWF	zn10

	CALL	zobraz

	RETURN

odp3
	MOVLW	pct
	MOVWF	zn11

	CALL	zobraz

	RETURN

odp4
	MOVLW	pct
	MOVWF	zn12

	CALL	zobraz

	RETURN

odp5
	MOVLW	pct
	MOVWF	zn13

	CALL	zobraz

	RETURN

odp6
	MOVLW	pct
	MOVWF	zn14

	CALL	zobraz

	RETURN

odp7
	MOVLW	pct
	MOVWF	zn15

	CALL	zobraz

	RETURN

odp8
	MOVLW	pct
	MOVWF	zn16

	CALL	zobraz

	RETURN

;-----Npis: Alarm aktivni
aktivni
	MOVLW	'A'
	MOVWF	zn01
	MOVLW	'l'
	MOVWF	zn02
	MOVLW	'a'
	MOVWF	zn03
	MOVLW	'r'
	MOVWF	zn04
	MOVLW	'm'
	MOVWF	zn05
	MOVLW	' '
	MOVWF	zn06
	MOVLW	' '
	MOVWF	zn07
	MOVLW	' '
	MOVWF	zn08

	MOVLW	'a'
	MOVWF	zn09
	MOVLW	'k'
	MOVWF	zn10
	MOVLW	't'
	MOVWF	zn11
	MOVLW	'i'
	MOVWF	zn12
	MOVLW	'v'
	MOVWF	zn13
	MOVLW	'n'
	MOVWF	zn14
	MOVLW	'i'
	MOVWF	zn15
	MOVLW	' '
	MOVWF	zn16

	CALL	zobraz

	RETURN

;----------------------------------------------------------------------------------------------------------------------------
;Zobrazen na displeji
;----------------------------------------------------------------------------------------------------------------------------
zobraz

;-----nastaven pozice DDRAM na prvn dek
	BCF		RS			;na portech bude INSTRUKCE
	MOVLW	b'10000000'	;adresa prvnho znaku
	MOVWF	LCD
	BSF		E			;povolen penosu
	NOP
	BCF		E
	CALL	cekani3		;ek asi 50us

;-----01
	BSF		RS		;na portech budou DATA
	MOVFW	zn01
	MOVWF	LCD	
	BSF		E		;povolen penosu
	NOP
	BCF		E
	CALL	cekani3	;ek asi 50us

;-----02
	MOVFW	zn02
	MOVWF	LCD	
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----03
	MOVFW	zn03
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----04
	MOVFW	zn04
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----05
	MOVFW	zn05
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----06
	MOVFW	zn06
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----07
	MOVFW	zn07
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----08
	MOVFW	zn08
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us

;-----nastaven pozice DDRAM na druh dek
	BCF		RS			;na portech bude INSTRUKCE
	MOVLW	b'11000000'	;porty displeje nastav na tuto hodnotu
	MOVWF	LCD
	BSF		E			;povolen penosu
	NOP
	BCF		E
	CALL	cekani3		;ek asi 50us

;-----09
	BSF		RS		;na portech budou DATA
	MOVFW	zn09
	MOVWF	LCD	
	BSF		E		;povolen penosu
	NOP
	BCF		E
	CALL	cekani3	;ek asi 50us

;-----10
	MOVFW	zn10
	MOVWF	LCD	
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----11
	MOVFW	zn11
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----12
	MOVFW	zn12
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----13
	MOVFW	zn13
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----14
	MOVFW	zn14
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----15
	MOVFW	zn15
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us
;-----16
	MOVFW	zn16
	MOVWF	LCD
	BSF		E		;povolen penosu
	NOP
	BCF		E		
	CALL	cekani3	;ek asi 50us

	RETURN

;----------------------------------------------------------------------------------------------------------------------------
;Podorogram pro	ppnut po stisku klvesy, poppad rozsvcen displeje, pokud alarm nejde na zlon zdroj
;----------------------------------------------------------------------------------------------------------------------------

pip
	BTFSS	pipej	;test, zda je zvuk zapnut
	GOTO	pip2

	MOVLW	.20		;ulo hodnoty pro dlku ppnut
	MOVWF	c2

pip1
	BSF		SIG		;aktivuje repro
	CALL	cekani4
	BCF		SIG		;deaktivuje piezo
	CALL	cekani4

	DECFSZ	c2,1	;odete 1 od registru urujcho dlku ppnut
	GOTO	pip1

pip2
	BTFSC	ZAL		;testuje bit zlohy pro ppadn skok v programu, aby se displej nerozsvtil
	BSF		LED

	RETURN

pip5
	CALL	pip
	CALL	cekani2
	CALL	pip
	CALL	cekani2
	CALL	pip
	CALL	cekani2
	CALL	pip
	CALL	cekani2
	CALL	pip

	RETURN

;----------------------------------------------------------------------------------------------------------------------------
;Podorogram pro uvolnn klves
;----------------------------------------------------------------------------------------------------------------------------
;---voln klvesy
kl_volne
	CALL	cekani2	;pok na ustlen ppadnho zkmitu
	CALL	pip
	BTFSC	ZAL		;testuje bit zlohy pro ppadn skok v programu, aby se displej nerozsvtil
	BSF		LED		;rozsvt LED, protoe bylo stisknuto tlatko
	BCF		odp_pod	;vynuluje pznak odpotu asu pro zhasnut, aby byl as opt nastaven na poten hodnotu

	BTFSC	KL1		;je klvesa uvolnna?
	GOTO	$-1		;ne - skok o instrukci v
	BTFSC	KL2		;ano - test dal
	GOTO	$-1
	BTFSC	KL3
	GOTO	$-1
	BTFSC	KL4
	GOTO	$-1
	
	RETURN

;----------------------------------------------------------------------------------------------------------------------------
;Podorogramy pro ekn
;----------------------------------------------------------------------------------------------------------------------------
;-------1,25s
cekani1	BCF		INTCON,GIE	;vechna peruen zakzna
		MOVLW	.10
		MOVWF	c3
cek1	MOVLW	.250
		MOVWF	c2
cek2	MOVLW	.250
		MOVWF	c1
cek3	DECFSZ	c1,1
		GOTO	cek3
		DECFSZ	c2,1
		GOTO	cek2
		DECFSZ	c3,1
		GOTO	cek1
		BSF		INTCON,GIE	;vechna peruen povolena
		RETURN

;-------20ms
cekani2	MOVLW	.100
		MOVWF	c2
cek4	MOVLW	.100
		MOVWF	c1
cek5	DECFSZ	c1,1
		GOTO	cek5
		DECFSZ	c2,1
		GOTO	cek4
		RETURN

;-------0,36mS
cekani3	MOVLW	.60
		MOVWF	c1
cek6	DECFSZ	c1,1
		GOTO	cek6
		RETURN

;-------90us
cekani4	MOVLW	.15
		MOVWF	c1
cek7	DECFSZ	c1,1
		GOTO	cek7
		RETURN

;----------------------------------------------------------------------------------------------------------------------------
;Podorogram pro peruen
;----------------------------------------------------------------------------------------------------------------------------
preruseni
	MOVWF	temp_W			;uloen stav systmovch registr pro jejich obnoven ped nvratem z peruen
	SWAPF	STATUS,w
	CLRF	STATUS
	MOVWF	temp_STAT
	MOVF	PCLATH,w
	MOVWF	temp_PCLATH
	CLRF	PCLATH

;-----odpoet pro zhasnut displeje
	BTFSS	LED
	GOTO	p2
	BTFSC	odp_pod
	GOTO	p1

	MOVLW	.150
	MOVWF	c4
	BSF		odp_pod
p1
	DECFSZ	c4,1
	GOTO	p2
	BCF		LED
	BCF		odp_pod
p2

;-----odpoet do zmny npisu pi inicializaci
	BTFSS	info
	GOTO	i2
	BTFSC	odp_in
	GOTO	i1

	MOVLW	.20
	MOVWF	c5
	BSF		odp_in
i1
	DECFSZ	c5,1
	GOTO	i2
	CALL	nap_info
	BCF		odp_in
i2

;-----odpoet do sputn poplachu po vstupu
	BTFSS	vstup
	GOTO	v2
	BTFSC	odp_vstup
	GOTO	v1

	MOVLW	.250
	MOVWF	c6
	BSF		odp_vstup
v1
	DECFSZ	c6,1
	GOTO	v2
	BSF		poplach
	BCF		odp_vstup
v2

	BTFSC	poplach
	BCF		OUT1

	BTFSS	poplach
	BSF		OUT1

;-----konec peruen
konecpreruseni
	BCF		INTCON,T0IF		;nastaven systmpvch regisr, pro nvrat z peruen
	MOVF	temp_PCLATH,w
	MOVWF	PCLATH
	SWAPF	temp_STAT,w
	MOVWF	STATUS
	SWAPF	temp_W,F
	SWAPF	temp_W,w

	RETFIE					;nvrat z peruen

;----------------------------------------------------------------------------------------------------------------------------
;Konec
;----------------------------------------------------------------------------------------------------------------------------
	END